## zint 2.12.0

=== CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2022 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.5)
project(zint-package)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(ZINT_VERSION_MAJOR 2)
set(ZINT_VERSION_MINOR 12)
set(ZINT_VERSION_RELEASE 0)
set(ZINT_VERSION_BUILD 0) # Set to 0 before release, set to 9 after release
set(ZINT_VERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}.${ZINT_VERSION_RELEASE}.${ZINT_VERSION_BUILD}")

add_definitions(-DZINT_VERSION=\"${ZINT_VERSION}\")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

option(ZINT_DEBUG    "Set debug compile flags"         OFF)
option(ZINT_NOOPT    "Set no optimize compile flags"   OFF)
option(ZINT_SANITIZE "Set sanitize compile/link flags" OFF)
option(ZINT_TEST     "Set test compile flag"           OFF)
option(ZINT_COVERAGE "Set code coverage flags"         OFF)
option(ZINT_SHARED   "Build shared library"            ON)
option(ZINT_STATIC   "Build static library"            OFF)
option(ZINT_USE_PNG  "Build with PNG support"          ON)
option(ZINT_USE_QT   "Build with Qt support"           ON)
option(ZINT_QT6      "If ZINT_USE_QT, use Qt6"         OFF)

include(SetPaths.cmake)

include(CheckCXXCompilerFlag)
include(CheckFunctionExists)

if(NOT MSVC) # Use default warnings if MSVC otherwise inundated
    check_cxx_compiler_flag("-Wall" CXX_COMPILER_FLAG_WALL)
    if(CXX_COMPILER_FLAG_WALL)
        add_compile_options("-Wall")
    endif()

    check_cxx_compiler_flag("-Wextra" CXX_COMPILER_FLAG_WEXTRA)
    if(CXX_COMPILER_FLAG_WEXTRA)
        add_compile_options("-Wextra")
    endif()

    check_cxx_compiler_flag("-Wpedantic" CXX_COMPILER_FLAG_WPEDANTIC)
    if(CXX_COMPILER_FLAG_WPEDANTIC)
        add_compile_options("-Wpedantic")
    endif()
endif()

if(ZINT_DEBUG)
    check_cxx_compiler_flag("-g" CXX_COMPILER_FLAG_G)
    if(CXX_COMPILER_FLAG_G)
        add_compile_options("-g")
    endif()
endif()

if(ZINT_NOOPT)
    check_cxx_compiler_flag("-O0" CXX_COMPILER_FLAG_O0)
    if(CXX_COMPILER_FLAG_O0)
        add_compile_options("-O0")
    endif()
endif()

if(ZINT_SANITIZE)
    if(MSVC)
        if(MSVC_VERSION GREATER_EQUAL 1920)
            add_compile_options(-fsanitize=address)
            message(STATUS "ZINT_SANITIZE: setting -fsanitize=address for MSVC 2019")
        else()
            message(STATUS "ZINT_SANITIZE: ignoring for MSVC < 2019")
        endif()
    else()
        set(SANITIZERS address undefined)
        foreach(sanitizer IN ITEMS ${SANITIZERS})
            set(CMAKE_REQUIRED_LIBRARIES -fsanitize=${sanitizer})
            check_cxx_compiler_flag(-fsanitize=${sanitizer} CXX_COMPILER_FLAG_FSANITIZE_${sanitizer})
            if(CXX_COMPILER_FLAG_FSANITIZE_${sanitizer})
                add_compile_options(-fsanitize=${sanitizer})
                link_libraries(-fsanitize=${sanitizer})
            endif()
            unset(CMAKE_REQUIRED_LIBRARIES)
        endforeach()

        if(NOT ZINT_DEBUG AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
            # Gives warning on MainWindow::setupUI() and retries (& takes forever) if var-tracking-assignments enabled
            add_compile_options(-fno-var-tracking-assignments)
        endif()
    endif()
endif()

if(ZINT_TEST)
    enable_testing()
endif()

if(ZINT_COVERAGE)
    set(CMAKE_REQUIRED_LIBRARIES -fprofile-arcs)
    check_cxx_compiler_flag(--coverage CXX_COMPILER_FLAG_COVERAGE)
    unset(CMAKE_REQUIRED_LIBRARIES)
    if(CXX_COMPILER_FLAG_COVERAGE)
        add_compile_options(--coverage)
        link_libraries(-fprofile-arcs)

        check_cxx_compiler_flag(-O0 CXX_COMPILER_FLAG_O0)
        if(CXX_COMPILER_FLAG_O0)
            add_compile_options(-O0)
        endif()
    endif()
endif()

if(APPLE)
    if(UNIVERSAL) # TODO: make universal binary
        if(NOT ZINT_HAS_BEEN_RUN_BEFORE)
            if(EXISTS /Developer/SDKs/MacOSX10.5.sdk OR EXISTS /SDKs/MacOSX10.5.sdk)
                set(CMAKE_OSX_ARCHITECTURES "ppc;i386;ppc64;x86_64" CACHE STRING "Build architectures for OSX" FORCE)
                set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden -Wl -single_module " CACHE STRING
                    "Flags used by the compiler during all build types." FORCE)
            elseif(EXISTS /Developer/SDKs/MacOSX10.4u.sdk OR EXISTS /SDKs/MacOSX10.4u.sdk)
                set(CMAKE_OSX_ARCHITECTURES "ppc;i386" CACHE STRING "Build architectures for OSX" FORCE)
                set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden -Wl -single_module " CACHE STRING
                    "Flags used by the compiler during all build types." FORCE)
            endif()
            message("Build architectures for OSX:${CMAKE_OSX_ARCHITECTURES}")
        endif()
    else()
        set(CMAKE_OSX_SYSROOT "/")
    endif()
endif()

check_function_exists(getopt HAVE_GETOPT)
if(NOT HAVE_GETOPT)
    add_subdirectory(getopt)
endif()

add_subdirectory(backend)
add_subdirectory(frontend)

if(NOT ZINT_USE_QT)
    message(STATUS "Qt support was disabled for this build")
elseif(ZINT_QT6 OR ($ENV{CMAKE_PREFIX_PATH} MATCHES "6[.][0-9][.][0-9]"))
    set(USE_QT6 TRUE)
    message(STATUS "Using Qt6")
    cmake_policy(SET CMP0012 NEW) # Recognize constants in if()
    cmake_policy(SET CMP0072 NEW) # Choose OpenGL over legacy GL
    find_package(Qt6Widgets)
    find_package(Qt6Gui)
    find_package(Qt6UiTools)
    find_package(Qt6Svg)

    if(Qt6Widgets_FOUND AND Qt6Gui_FOUND AND Qt6UiTools_FOUND AND Qt6Svg_FOUND)
        message(STATUS "Qt version: " ${Qt6Core_VERSION_MAJOR}.${Qt6Core_VERSION_MINOR}.${Qt6Core_VERSION_PATCH})
        add_subdirectory(backend_qt)
        add_subdirectory(frontend_qt)
    else()
        message(STATUS "Could NOT find Qt6")
    endif()
else()
    message(STATUS "Using Qt5")
    find_package(Qt5Widgets)
    find_package(Qt5Gui)
    find_package(Qt5UiTools)
    find_package(Qt5Svg)

    if(Qt5Widgets_FOUND AND Qt5Gui_FOUND AND Qt5UiTools_FOUND AND Qt5Svg_FOUND)
        message(STATUS "Qt version: " ${Qt5Core_VERSION_STRING})
        # Old Qt does not provide QT_VERSION_MAJOR
        if (NOT QT_VERSION_MAJOR)
            string(SUBSTRING ${Qt5Core_VERSION_STRING} 0 1 QT_VERSION_MAJOR)
        endif()
        add_subdirectory(backend_qt)
        add_subdirectory(frontend_qt)
    else()
        message(STATUS "Could NOT find Qt5")
    endif()
endif()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# staniek: don't install
if(DATA_INSTALL_DIR)
    set(CMAKE_MODULES_INSTALL_PATH ${DATA_INSTALL_DIR}/cmake/modules)
else()
    set(CMAKE_MODULES_INSTALL_PATH ${CMAKE_ROOT}/Modules)
endif()

install(FILES cmake/modules/FindZint.cmake DESTINATION ${CMAKE_MODULES_INSTALL_PATH} COMPONENT Devel)
configure_file("zint-config.cmake.in" "zint-config.cmake" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/zint-config.cmake" DESTINATION "${SHARE_INSTALL_PREFIX}/zint")

# This needs to be run very last so other parts of the scripts can take
# advantage of this.
if(NOT ZINT_HAS_BEEN_RUN_BEFORE)
    set(ZINT_HAS_BEEN_RUN_BEFORE 1 CACHE INTERNAL
        "Flag to track whether this is the first time running CMake or if CMake has been configured before")
endif()

=== backend/CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2022 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

project(zint)

set(zint_COMMON_SRCS common.c library.c large.c reedsol.c gs1.c eci.c general_field.c)
set(zint_ONEDIM_SRCS bc412.c code.c code128.c 2of5.c upcean.c telepen.c medical.c plessey.c rss.c)
set(zint_POSTAL_SRCS postal.c auspost.c imail.c mailmark.c)
set(zint_TWODIM_SRCS code16k.c codablock.c dmatrix.c pdf417.c qr.c maxicode.c composite.c aztec.c code49.c code1.c gridmtx.c hanxin.c dotcode.c ultra.c)
set(zint_OUTPUT_SRCS vector.c ps.c svg.c emf.c bmp.c pcx.c gif.c png.c tif.c raster.c output.c)
set(zint_SRCS ${zint_OUTPUT_SRCS} ${zint_COMMON_SRCS} ${zint_ONEDIM_SRCS} ${zint_POSTAL_SRCS} ${zint_TWODIM_SRCS})

if(ZINT_SHARED)
    add_library(zint SHARED ${zint_SRCS})

    if(WIN32)
        target_sources(${PROJECT_NAME} PRIVATE libzint.rc)
    endif()
endif()

if(ZINT_STATIC)
    add_library(zint-static STATIC ${zint_SRCS})
    if(WIN32)
        set_target_properties(zint-static PROPERTIES OUTPUT_NAME zint-static)
    else()
        set_target_properties(zint-static PROPERTIES OUTPUT_NAME zint)
    endif()
endif()

function(zint_target_link_libraries library)
    if(ZINT_SHARED)
        target_link_libraries(zint ${library})
    endif()
    if(ZINT_STATIC)
        target_link_libraries(zint-static ${library})
    endif()
endfunction()

function(zint_target_compile_definitions scope definition)
    if(ZINT_SHARED)
        target_compile_definitions(zint ${scope} ${definition})
    endif()
    if(ZINT_STATIC)
        target_compile_definitions(zint-static ${scope} ${definition})
    endif()
endfunction()

function(zint_target_include_directories scope directory)
    if(ZINT_SHARED)
        target_include_directories(zint ${scope} ${directory})
    endif()
    if(ZINT_STATIC)
        target_include_directories(zint-static ${scope} ${directory})
    endif()
endfunction()

if(ZINT_SHARED)
    set_target_properties(zint PROPERTIES   SOVERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}"
                                            VERSION ${ZINT_VERSION})
endif()

if(ZINT_USE_PNG)
    find_package(PNG)
endif()

if(ZINT_USE_PNG AND PNG_FOUND)
    zint_target_link_libraries(PNG::PNG)
else()
    zint_target_compile_definitions(PRIVATE ZINT_NO_PNG)
endif()

if(ZINT_TEST)
    zint_target_compile_definitions(PUBLIC ZINT_TEST)
endif()

if(NOT MSVC)
    # Link with standard C math library.
    zint_target_link_libraries(m)
endif()

if(MSVC)
    target_compile_definitions(zint PRIVATE DLL_EXPORT)
endif()

zint_target_include_directories(PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${INCLUDE_INSTALL_DIR}>
)

if(ZINT_SHARED)
    install(TARGETS zint EXPORT zint-targets ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()
if(ZINT_STATIC)
    install(TARGETS zint-static EXPORT zint-targets ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()
install(EXPORT zint-targets NAMESPACE zint:: DESTINATION "${SHARE_INSTALL_PREFIX}/zint")
install(FILES zint.h DESTINATION ${INCLUDE_INSTALL_DIR} COMPONENT Devel)

if(ZINT_TEST)
    add_subdirectory(tests)
endif()

=== backend_qt/CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2021 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

project(QZint)

set(${PROJECT_NAME}_SRCS qzint.cpp)

if(USE_QT6)
    qt6_wrap_cpp(QZint_SRCS qzint.h)
else()
    qt5_wrap_cpp(QZint_SRCS qzint.h)
endif()

add_library(${PROJECT_NAME} STATIC ${QZint_SRCS})

set_target_properties(${PROJECT_NAME} PROPERTIES  SOVERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}"
                                        VERSION ${ZINT_VERSION})

target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_SOURCE_DIR}/backend")

if(ZINT_SHARED)
    target_link_libraries(${PROJECT_NAME} zint)
else()
    target_link_libraries(${PROJECT_NAME} zint-static)
endif()
target_link_libraries(${PROJECT_NAME} Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Gui)

if(ZINT_TEST)
    add_subdirectory(tests)
endif()

install(TARGETS ${PROJECT_NAME} ${INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES qzint.h DESTINATION ${INCLUDE_INSTALL_DIR} COMPONENT Devel)

=== docs/Makefile ===
# Makefile for generating "manual.txt" and "manual.pdf" from "manual.pmd" using pandoc
# Copyright (C) 2022 <rstuart114@gmail.com>
#
# Requires a recent version of pandoc, plus pandoc-tablenos, xelatex and various other packages - see "README"
# .svg images generated by "zint_images.sh"

SOURCE = manual.pmd
OUT_PDF = manual.pdf
OUT_TXT = manual.txt
INC_HEADER_PDF = inc_header_pdf.tex
INC_BEFORE_BODY_PDF = inc_before_body_pdf.tex
INCLUDES_PDF = $(INC_HEADER_PDF) $(INC_BEFORE_BODY_PDF)
INC_PDF = --include-in-header $(INC_HEADER_PDF) --include-before-body $(INC_BEFORE_BODY_PDF)
INCLUDES_TXT = inc_header_txt.tex
INC_TXT = --include-in-header $(INCLUDES_TXT)
SOURCE_MAN_PAGE = zint.1.pmd
OUT_MAN_PAGE = zint.1
IMAGES = \
	images/zint.png \
	images/zint-qt.png \
	images/gui_main.png \
	images/gui_delete.png \
	images/gui_zap.png \
	images/gui_menus.png \
	images/gui_composite.png \
	images/gui_segs.png \
	images/gui_aztec.png \
	images/gui_appearance.png \
	images/gui_scaling.png \
	images/gui_set_printing_scale.png \
	images/gui_black_eye.png \
	images/gui_white_eye.png \
	images/gui_swap.png \
	images/gui_colour.png \
	images/gui_data_dialog.png \
	images/gui_sequence.png \
	images/gui_export.png \
	images/gui_cli_equivalent.png \
	images/pdf417_heightperrow.svg \
	images/code128_box.svg \
	images/qrcode_box.svg \
	images/code128_green.svg \
	images/code128_green_alpha.svg \
	images/code128_rotate90.svg \
	images/datamatrix_euro.svg \
	images/datamatrix_big5.svg \
	images/qrcode_binary_utf8.svg \
	images/codeone_s_dotty.svg \
	images/aztec_segs.svg \
	images/datamatrix_structapp.svg \
	images/code128_small_bold.svg \
	images/code11.svg \
	images/c25standard.svg \
	images/c25iata.svg \
	images/c25ind.svg \
	images/c25inter.svg \
	images/c25logic.svg \
	images/itf14.svg \
	images/itf14_border0.svg \
	images/dpleit.svg \
	images/dpident.svg \
	images/upca.svg \
	images/upca_5.svg \
	images/upce.svg \
	images/eanx13.svg \
	images/eanx5.svg \
	images/eanx8_5.svg \
	images/isbnx.svg \
	images/plessey.svg \
	images/msi_plessey.svg \
	images/telepen.svg \
	images/telepen_num.svg \
	images/code39.svg \
	images/excode39.svg \
	images/code93.svg \
	images/pzn.svg \
	images/logmars.svg \
	images/code32.svg \
	images/hibc_39.svg \
	images/vin.svg \
	images/codabar.svg \
	images/pharma.svg \
	images/code128.svg \
	images/code128ab.svg \
	images/gs1_128.svg \
	images/ean14.svg \
	images/nve18.svg \
	images/hibc_128.svg \
	images/dpd.svg \
	images/upu_s10.svg \
	images/dbar_omn.svg \
	images/dbar_truncated.svg \
	images/dbar_ltd.svg \
	images/dbar_exp.svg \
	images/koreapost.svg \
	images/channel.svg \
	images/bc412.svg \
	images/code128_stacked.svg \
	images/code128_stacked_sep2.svg \
	images/codablockf.svg \
	images/code16k.svg \
	images/pdf417.svg \
	images/pdf417comp.svg \
	images/micropdf417.svg \
	images/dbar_stk.svg \
	images/dbar_omnstk.svg \
	images/dbar_expstk.svg \
	images/code49.svg \
	images/eanx_cc_a.svg \
	images/eanx_cc_b.svg \
	images/gs1_128_cc_c.svg \
	images/pharma_two.svg \
	images/postnet.svg \
	images/planet.svg \
	images/auspost.svg \
	images/ausroute.svg \
	images/ausreply.svg \
	images/ausredirect.svg \
	images/kix.svg \
	images/rm4scc.svg \
	images/mailmark_4s.svg \
	images/usps_imail.svg \
	images/japanpost.svg \
	images/hibc_dm.svg \
	images/mailmark_2d.svg \
	images/qrcode.svg \
	images/microqr.svg \
	images/rmqr.svg \
	images/upnqr.svg \
	images/maxicode.svg \
	images/aztec.svg \
	images/azrune.svg \
	images/codeone.svg \
	images/gridmatrix.svg \
	images/dotcode.svg \
	images/hanxin.svg \
	images/ultra.svg \
	images/fim.svg \
	images/flat.svg \
	images/daft_rm4scc.svg
MAIN_FONT = mainfont="TeX Gyre Pagella"
MONO_FONT = monofont="Liberation Mono"
CJK_FONT = CJKmainfont="WenQuanYi Micro Hei Mono"
PDF_OPTS = --pdf-engine=xelatex --filter pandoc-tablenos -M tablenos-warning-level=0 \
			--highlight-style=haddock -V colorlinks -V geometry:margin=20mm -V papersize=a4 -V csquotes=true --dpi=300
TEX_MAN_PAGE = zint.1.tex
TXT_OPTS = --filter pandoc-tablenos -M tablenos-warning-level=0 --columns 80 --eol=lf -t plain
MAN_PAGE_OPTS = -s -t man

all : $(OUT_PDF) $(OUT_TXT) $(OUT_MAN_PAGE)

$(OUT_PDF) : $(SOURCE) $(SOURCE_MAN_PAGE) $(HIGHLIGHT_THEME) $(INC_HEADER_PDF) $(INC_BEFORE_BODY_PDF) $(IMAGES) Makefile
	pandoc $(SOURCE_MAN_PAGE) -f markdown \
			$(PDF_OPTS) \
			-o $(TEX_MAN_PAGE)
	sed -i -e 's/section{/subsection{/' $(TEX_MAN_PAGE) # Convert man page sections to subsections
	pandoc $(SOURCE) -f markdown $(INC_PDF) --toc --toc-depth=4 \
			-V $(MAIN_FONT) -V $(MONO_FONT) -V $(CJK_FONT) -V block-headings \
			$(PDF_OPTS) \
			--include-after-body $(TEX_MAN_PAGE) \
			-o $(OUT_PDF)

$(OUT_TXT) : $(SOURCE) $(SOURCE_MAN_PAGE) $(INCLUDES_TXT) Makefile
	pandoc $(SOURCE) $(SOURCE_MAN_PAGE) -f markdown $(INC_TXT) --toc --toc-depth=4 \
			-V $(MAIN_FONT) -V $(MONO_FONT) -V $(CJK_FONT) \
			$(TXT_OPTS) \
			-o $(OUT_TXT)
	# Indent Man Page sections in TOC and remove trailing spaces
	sed -i \
		-e 's/^\(-   [A-Z][A-Z ]*\)$$/    \1/' \
		-e 's/  *$$//' \
		$(OUT_TXT)

$(OUT_MAN_PAGE) : $(SOURCE_MAN_PAGE) Makefile
	pandoc $(SOURCE_MAN_PAGE) -f markdown \
			$(MAN_PAGE_OPTS) \
			-o $(OUT_MAN_PAGE)

=== frontend/CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2021 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

project(zint_frontend)

set(${PROJECT_NAME}_SRCS main.c)

add_executable(${PROJECT_NAME} ${zint_frontend_SRCS})

if(WIN32)
    target_sources(${PROJECT_NAME} PRIVATE zint.rc)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_SOURCE_DIR}/backend")

set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "zint")

if(ZINT_SHARED)
    target_link_libraries(${PROJECT_NAME} zint)
else()
    target_link_libraries(${PROJECT_NAME} zint-static)
endif()
if(NOT HAVE_GETOPT)
    target_link_libraries(${PROJECT_NAME} zint_bundled_getopt)
endif()

install(TARGETS ${PROJECT_NAME} DESTINATION "${BIN_INSTALL_DIR}" RUNTIME)
if(UNIX)
    install(FILES "${CMAKE_SOURCE_DIR}/docs/zint.1" DESTINATION "${MAN_INSTALL_DIR}/man1" COMPONENT doc)
endif()

if(ZINT_TEST)
    add_subdirectory(tests)
endif()

=== frontend_qt/CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2022 Robin Stuart <rstuart114@gmail.com>
# SPDX-License-Identifier: GPL-3.0-or-later
# vim: set ts=4 sw=4 et :

project(zint-qt)

set(CMAKE_AUTORCC ON)

set(${PROJECT_NAME}_SRCS barcodeitem.cpp main.cpp mainwindow.cpp
                            cliwindow.cpp datawindow.cpp scalewindow.cpp sequencewindow.cpp exportwindow.cpp)

if(USE_QT6)
    qt6_wrap_cpp(zint-qt_SRCS mainwindow.h cliwindow.h datawindow.h scalewindow.h sequencewindow.h exportwindow.h)
    qt6_wrap_ui(zint-qt_SRCS mainWindow.ui extCLI.ui extData.ui extScale.ui extSequence.ui extExport.ui)
else()
    qt5_wrap_cpp(zint-qt_SRCS mainwindow.h cliwindow.h datawindow.h scalewindow.h sequencewindow.h exportwindow.h)
    qt5_wrap_ui(zint-qt_SRCS mainWindow.ui extCLI.ui extData.ui extScale.ui extSequence.ui extExport.ui)
endif()

#           grpAztec.ui  grpC39.ui      grpCodablockF.ui  grpDotCode.ui  grpMailmark2D.ui  grpPDF417.ui  grpUPCA.ui
#           grpC11.ui    grpC49.ui      grpCodeOne.ui     grpDPD.ui      grpMaxicode.ui    grpPZN.ui     grpUPCEAN.ui
#           grpC128.ui   grpC93.ui      grpDAFT.ui        grpGrid.ui     grpMicroPDF.ui    grpQR.ui      grpUPNQR.ui
#           grpC16k.ui   grpChannel.ui  grpDBExtend.ui    grpHX.ui       grpMQR.ui         grpRMQR.ui    grpVIN.ui
#           grpC25.ui    grpCodabar.ui  grpDM.ui          grpITF14.ui    grpMSICheck.ui    grpUltra.ui

if(APPLE)
    # https://doc.qt.io/qt-5/appicon.html
    set(MACOSX_BUNDLE_ICON_FILE zint-qt.icns)
    set(APP_ICON_MACOSX "${CMAKE_CURRENT_SOURCE_DIR}/zint-qt.icns")
    set_source_files_properties(${APP_ICON_MACOSX} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
    add_executable(${PROJECT_NAME} MACOSX_BUNDLE ${zint-qt_SRCS} resources.qrc ${APP_ICON_MACOSX})
    set_target_properties(${PROJECT_NAME} PROPERTIES
        MACOSX_BUNDLE TRUE
        MACOSX_BUNDLE_BUNDLE_NAME "Zint Barcode Studio"
        MACOSX_BUNDLE_BUNDLE_VERSION ${ZINT_VERSION}
        MACOSX_BUNDLE_COPYRIGHT "Copyright © 2006-2022 Robin Stuart and others"
        MACOSX_BUNDLE_GUI_IDENTIFIER "uk.org.zint.zint-qt"
        MACOSX_BUNDLE_INFO_STRING "A free barcode generator"
        MACOSX_BUNDLE_SHORT_VERSION_STRING ${ZINT_VERSION})
else()
    add_executable(${PROJECT_NAME} ${zint-qt_SRCS} resources.qrc)
endif()

if(WIN32)
    target_sources(${PROJECT_NAME} PRIVATE res/qtZint.rc)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_SOURCE_DIR}/backend" "${CMAKE_SOURCE_DIR}/backend_qt")

if(ZINT_SHARED)
    target_link_libraries(${PROJECT_NAME} zint)
else()
    target_link_libraries(${PROJECT_NAME} zint-static)
endif()
target_link_libraries(${PROJECT_NAME} QZint
                        Qt${QT_VERSION_MAJOR}::UiTools Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Svg
                        Qt${QT_VERSION_MAJOR}::Core)


install(TARGETS ${PROJECT_NAME} DESTINATION "${BIN_INSTALL_DIR}" RUNTIME)

=== debian/changelog ===
zint (2.12.0-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.6.2.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 07 Feb 2023 02:14:01 +1100

=== debian/control ===
Source: zint
Section: graphics
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Jakob Haufe <sur5r@debian.org>
Build-Depends: debhelper-compat (= 12)
    ,cmake
    ,libpng-dev
    ,libqt5svg5-dev
    ,qtbase5-dev
    ,qttools5-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/zint
Vcs-Git: https://salsa.debian.org/debian/zint.git
Homepage: https://sourceforge.net/projects/zint/
Rules-Requires-Root: no

Package: zint
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command line utility to encode data in barcode symbols
 Zint is a barcode encoding and image generating library. It currently
 features support for over 50 symbologies including Australian Post
 4-state codes (redirect, reply-paid, routing, standard customer),
 Aztec Code (ISO 24778), Aztec Runes, Channel code, Codabar, Code 11,
 Code 128 (ISO 15417), Code 16k, Code 2 of 5 (Data Logic, IATA,
 Industrial, Interleaved, Matrix), Code 32 (Italian Pharmacode), Code
 39 (ISO 16388), Code 39 Extended, Code 49, Code 93, Code One, Databar
 (Expanded, Expanded Stacked, Limited, Stacked Omnidirectional), Data
 Matrix (ISO 16022), Deutsche Post (Identicode, Leitcode), Dutch Post
 KIX, EAN-14, European Article Number (EAN), Facing Identification
 Mark (FIM), Flattermarken, Grid Matrix, ITF-14, International Standard
 Book Number (ISBN), Japanese Postal Barcode, Korean Postal Barcode,
 LOGMARS, Maxicode (ISO 16023), MicroPDF417 (ISO 24728), Micro QR
 Code, MSI Plessey, NVE-18, PDF417 (ISO 15438), Pharmacode (2-track,
 Zentralnummer (PZN)), PLANET, Postnet, QR Code (ISO 18004), Royal
 Mail 4-state Barcode, Telepen, Telepen Numeric, UK Plessey, Universal
 Product Code (UPC-A, UPC-E), USPS Intelligent Mail as well as HIBC.
 .
 Also included are Unicode translation for symbologies which support
 Latin-1 and Kanji character sets, full GS1 data support including
 verification and automated insertion of FNC1 characters and support for
 encoding binary data including NULL (ASCII 0) characters.
 .
 This package contains Zint Barcode Generator (command-line utility).

Package: zint-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Zint Barcode Studio, a QT frontend to zint
 Zint is a barcode encoding and image generating library. It currently
 features support for over 50 symbologies including Australian Post
 4-state codes (redirect, reply-paid, routing, standard customer),
 Aztec Code (ISO 24778), Aztec Runes, Channel code, Codabar, Code 11,
 Code 128 (ISO 15417), Code 16k, Code 2 of 5 (Data Logic, IATA,
 Industrial, Interleaved, Matrix), Code 32 (Italian Pharmacode), Code
 39 (ISO 16388), Code 39 Extended, Code 49, Code 93, Code One, Databar
 (Expanded, Expanded Stacked, Limited, Stacked Omnidirectional), Data
 Matrix (ISO 16022), Deutsche Post (Identicode, Leitcode), Dutch Post
 KIX, EAN-14, European Article Number (EAN), Facing Identification
 Mark (FIM), Flattermarken, Grid Matrix, ITF-14, International Standard
 Book Number (ISBN), Japanese Postal Barcode, Korean Postal Barcode,
 LOGMARS, Maxicode (ISO 16023), MicroPDF417 (ISO 24728), Micro QR
 Code, MSI Plessey, NVE-18, PDF417 (ISO 15438), Pharmacode (2-track,
 Zentralnummer (PZN)), PLANET, Postnet, QR Code (ISO 18004), Royal
 Mail 4-state Barcode, Telepen, Telepen Numeric, UK Plessey, Universal
 Product Code (UPC-A, UPC-E), USPS Intelligent Mail as well as HIBC.
 .
 Also included are Unicode translation for symbologies which support
 Latin-1 and Kanji character sets, full GS1 data support including
 verification and automated insertion of FNC1 characters and support for
 encoding binary data including NULL (ASCII 0) characters.
 .
 This package contains Zint Barcode Studio, a QT frontend for the Zint
 barcode encoding library.

Package: libzint2.12
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for encoding data in barcode symbols
 Zint is a barcode encoding and image generating library. It currently
 features support for over 50 symbologies including Australian Post
 4-state codes (redirect, reply-paid, routing, standard customer),
 Aztec Code (ISO 24778), Aztec Runes, Channel code, Codabar, Code 11,
 Code 128 (ISO 15417), Code 16k, Code 2 of 5 (Data Logic, IATA,
 Industrial, Interleaved, Matrix), Code 32 (Italian Pharmacode), Code
 39 (ISO 16388), Code 39 Extended, Code 49, Code 93, Code One, Databar
 (Expanded, Expanded Stacked, Limited, Stacked Omnidirectional), Data
 Matrix (ISO 16022), Deutsche Post (Identicode, Leitcode), Dutch Post
 KIX, EAN-14, European Article Number (EAN), Facing Identification
 Mark (FIM), Flattermarken, Grid Matrix, ITF-14, International Standard
 Book Number (ISBN), Japanese Postal Barcode, Korean Postal Barcode,
 LOGMARS, Maxicode (ISO 16023), MicroPDF417 (ISO 24728), Micro QR
 Code, MSI Plessey, NVE-18, PDF417 (ISO 15438), Pharmacode (2-track,
 Zentralnummer (PZN)), PLANET, Postnet, QR Code (ISO 18004), Royal
 Mail 4-state Barcode, Telepen, Telepen Numeric, UK Plessey, Universal
 Product Code (UPC-A, UPC-E), USPS Intelligent Mail as well as HIBC.
 .
 Also included are Unicode translation for symbologies which support
 Latin-1 and Kanji character sets, full GS1 data support including
 verification and automated insertion of FNC1 characters and support for
 encoding binary data including NULL (ASCII 0) characters.
 .
 This package provides barcode generator library.

Package: libzint-dev
Section: libdevel
Architecture: any
Depends: libzint2.12 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Zint development files
 Zint is a barcode encoding and image generating library. It currently
 features support for over 50 symbologies including Australian Post
 4-state codes (redirect, reply-paid, routing, standard customer),
 Aztec Code (ISO 24778), Aztec Runes, Channel code, Codabar, Code 11,
 Code 128 (ISO 15417), Code 16k, Code 2 of 5 (Data Logic, IATA,
 Industrial, Interleaved, Matrix), Code 32 (Italian Pharmacode), Code
 39 (ISO 16388), Code 39 Extended, Code 49, Code 93, Code One, Databar
 (Expanded, Expanded Stacked, Limited, Stacked Omnidirectional), Data
 Matrix (ISO 16022), Deutsche Post (Identicode, Leitcode), Dutch Post
 KIX, EAN-14, European Article Number (EAN), Facing Identification
 Mark (FIM), Flattermarken, Grid Matrix, ITF-14, International Standard
 Book Number (ISBN), Japanese Postal Barcode, Korean Postal Barcode,
 LOGMARS, Maxicode (ISO 16023), MicroPDF417 (ISO 24728), Micro QR
 Code, MSI Plessey, NVE-18, PDF417 (ISO 15438), Pharmacode (2-track,
 Zentralnummer (PZN)), PLANET, Postnet, QR Code (ISO 18004), Royal
 Mail 4-state Barcode, Telepen, Telepen Numeric, UK Plessey, Universal
 Product Code (UPC-A, UPC-E), USPS Intelligent Mail as well as HIBC.
 .
 Also included are Unicode translation for symbologies which support
 Latin-1 and Kanji character sets, full GS1 data support including
 verification and automated insertion of FNC1 characters and support for
 encoding binary data including NULL (ASCII 0) characters.
 .
 This package contains development files for the Zint barcode encoding
 library and for the Qt wrapper over the Zint library.

## zint 2.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
-# Copyright (C) 2009-2022 Robin Stuart <rstuart114@gmail.com>
+# Copyright (C) 2009-2023 Robin Stuart <rstuart114@gmail.com>
 # vim: set ts=4 sw=4 et :
 
 cmake_minimum_required(VERSION 3.5)
@@ -8,25 +8,31 @@
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
 set(ZINT_VERSION_MAJOR 2)
-set(ZINT_VERSION_MINOR 12)
+set(ZINT_VERSION_MINOR 13)
 set(ZINT_VERSION_RELEASE 0)
 set(ZINT_VERSION_BUILD 0) # Set to 0 before release, set to 9 after release
 set(ZINT_VERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}.${ZINT_VERSION_RELEASE}.${ZINT_VERSION_BUILD}")
 
 add_definitions(-DZINT_VERSION=\"${ZINT_VERSION}\")
 
-set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")
-
-option(ZINT_DEBUG    "Set debug compile flags"         OFF)
-option(ZINT_NOOPT    "Set no optimize compile flags"   OFF)
-option(ZINT_SANITIZE "Set sanitize compile/link flags" OFF)
-option(ZINT_TEST     "Set test compile flag"           OFF)
-option(ZINT_COVERAGE "Set code coverage flags"         OFF)
-option(ZINT_SHARED   "Build shared library"            ON)
-option(ZINT_STATIC   "Build static library"            OFF)
-option(ZINT_USE_PNG  "Build with PNG support"          ON)
-option(ZINT_USE_QT   "Build with Qt support"           ON)
-option(ZINT_QT6      "If ZINT_USE_QT, use Qt6"         OFF)
+set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
+
+option(ZINT_DEBUG     "Set debug compile flags"         OFF)
+option(ZINT_NOOPT     "Set no optimize compile flags"   OFF)
+option(ZINT_SANITIZE  "Set sanitize compile/link flags" OFF)
+option(ZINT_TEST      "Set test compile flag"           OFF)
+option(ZINT_COVERAGE  "Set code coverage flags"         OFF)
+option(ZINT_SHARED    "Build shared library"            ON)
+option(ZINT_STATIC    "Build static library"            OFF)
+option(ZINT_USE_PNG   "Build with PNG support"          ON)
+option(ZINT_USE_QT    "Build with Qt support"           ON)
+option(ZINT_QT6       "If ZINT_USE_QT, use Qt6"         OFF)
+option(ZINT_UNINSTALL "Add uninstall target"            ON)
+option(ZINT_FRONTEND  "Build frontend"                  ON)
+
+if(NOT ZINT_SHARED AND NOT ZINT_STATIC)
+    message(SEND_ERROR "Either ZINT_SHARED or ZINT_STATIC or both must be set")
+endif()
 
 include(SetPaths.cmake)
 
@@ -87,6 +93,10 @@
         if(NOT ZINT_DEBUG AND CMAKE_CXX_COMPILER_ID MATCHES "GNU")
             # Gives warning on MainWindow::setupUI() and retries (& takes forever) if var-tracking-assignments enabled
             add_compile_options(-fno-var-tracking-assignments)
+        endif()
+        if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+            # Recent clangs added deprecation warnings for `sprintf()` that are only triggered on sanitize - suppress
+            add_compile_options(-Wno-deprecated-declarations)
         endif()
     endif()
 endif()
@@ -135,7 +145,9 @@
 endif()
 
 add_subdirectory(backend)
-add_subdirectory(frontend)
+if(ZINT_FRONTEND)
+    add_subdirectory(frontend)
+endif()
 
 if(NOT ZINT_USE_QT)
     message(STATUS "Qt support was disabled for this build")
@@ -176,13 +188,15 @@
     endif()
 endif()
 
-configure_file(
-  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
-  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
-  IMMEDIATE @ONLY)
-
-add_custom_target(uninstall
-  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
+if(ZINT_UNINSTALL)
+    configure_file(
+      "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
+      "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
+      IMMEDIATE @ONLY)
+    
+    add_custom_target(uninstall
+      "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
+endif()
 
 # staniek: don't install
 if(DATA_INSTALL_DIR)

=== backend/CMakeLists.txt ===
--- 
+++ 
@@ -4,11 +4,19 @@
 
 project(zint)
 
+if(ZINT_USE_PNG)
+    find_package(PNG)
+endif()
+
 set(zint_COMMON_SRCS common.c library.c large.c reedsol.c gs1.c eci.c general_field.c)
 set(zint_ONEDIM_SRCS bc412.c code.c code128.c 2of5.c upcean.c telepen.c medical.c plessey.c rss.c)
 set(zint_POSTAL_SRCS postal.c auspost.c imail.c mailmark.c)
 set(zint_TWODIM_SRCS code16k.c codablock.c dmatrix.c pdf417.c qr.c maxicode.c composite.c aztec.c code49.c code1.c gridmtx.c hanxin.c dotcode.c ultra.c)
-set(zint_OUTPUT_SRCS vector.c ps.c svg.c emf.c bmp.c pcx.c gif.c png.c tif.c raster.c output.c)
+if(ZINT_USE_PNG AND PNG_FOUND)
+    set(zint_OUTPUT_SRCS vector.c ps.c svg.c emf.c bmp.c pcx.c gif.c png.c tif.c raster.c output.c)
+else()
+    set(zint_OUTPUT_SRCS vector.c ps.c svg.c emf.c bmp.c pcx.c gif.c tif.c raster.c output.c)
+endif()
 set(zint_SRCS ${zint_OUTPUT_SRCS} ${zint_COMMON_SRCS} ${zint_ONEDIM_SRCS} ${zint_POSTAL_SRCS} ${zint_TWODIM_SRCS})
 
 if(ZINT_SHARED)
@@ -46,12 +54,12 @@
     endif()
 endfunction()
 
-function(zint_target_include_directories scope directory)
+function(zint_target_include_directories)
     if(ZINT_SHARED)
-        target_include_directories(zint ${scope} ${directory})
+        target_include_directories(zint ${ARGN})
     endif()
     if(ZINT_STATIC)
-        target_include_directories(zint-static ${scope} ${directory})
+        target_include_directories(zint-static ${ARGN})
     endif()
 endfunction()
 
@@ -60,14 +68,12 @@
                                             VERSION ${ZINT_VERSION})
 endif()
 
-if(ZINT_USE_PNG)
-    find_package(PNG)
-endif()
-
 if(ZINT_USE_PNG AND PNG_FOUND)
     zint_target_link_libraries(PNG::PNG)
+    message(STATUS "Using PNG")
 else()
     zint_target_compile_definitions(PRIVATE ZINT_NO_PNG)
+    message(STATUS "Not using PNG")
 endif()
 
 if(ZINT_TEST)
@@ -80,7 +86,9 @@
 endif()
 
 if(MSVC)
-    target_compile_definitions(zint PRIVATE DLL_EXPORT)
+    if(ZINT_SHARED)
+        target_compile_definitions(zint PRIVATE DLL_EXPORT)
+    endif()
 endif()
 
 zint_target_include_directories(PUBLIC

=== backend_qt/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 set_target_properties(${PROJECT_NAME} PROPERTIES  SOVERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}"
                                         VERSION ${ZINT_VERSION})
 
-target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_SOURCE_DIR}/backend")
+target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/../backend")
 
 if(ZINT_SHARED)
     target_link_libraries(${PROJECT_NAME} zint)

=== docs/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-# Makefile for generating "manual.txt" and "manual.pdf" from "manual.pmd" using pandoc
-# Copyright (C) 2022 <rstuart114@gmail.com>
+# Makefile for generating "manual.txt" and "manual.pdf" from "manual.pmd" and "zint.1" from "zint.1.pmd" using pandoc
+# Copyright (C) 2022-2023 <rstuart114@gmail.com>
 #
 # Requires a recent version of pandoc, plus pandoc-tablenos, xelatex and various other packages - see "README"
 # .svg images generated by "zint_images.sh"
@@ -9,7 +9,6 @@
 OUT_TXT = manual.txt
 INC_HEADER_PDF = inc_header_pdf.tex
 INC_BEFORE_BODY_PDF = inc_before_body_pdf.tex
-INCLUDES_PDF = $(INC_HEADER_PDF) $(INC_BEFORE_BODY_PDF)
 INC_PDF = --include-in-header $(INC_HEADER_PDF) --include-before-body $(INC_BEFORE_BODY_PDF)
 INCLUDES_TXT = inc_header_txt.tex
 INC_TXT = --include-in-header $(INCLUDES_TXT)
@@ -24,6 +23,7 @@
 	images/gui_menus.png \
 	images/gui_composite.png \
 	images/gui_segs.png \
+	images/gui_c25inter.png \
 	images/gui_aztec.png \
 	images/gui_appearance.png \
 	images/gui_scaling.png \
@@ -36,6 +36,7 @@
 	images/gui_sequence.png \
 	images/gui_export.png \
 	images/gui_cli_equivalent.png \
+	images/tcl_demo.png \
 	images/pdf417_heightperrow.svg \
 	images/code128_box.svg \
 	images/qrcode_box.svg \
@@ -149,7 +150,7 @@
 
 all : $(OUT_PDF) $(OUT_TXT) $(OUT_MAN_PAGE)
 
-$(OUT_PDF) : $(SOURCE) $(SOURCE_MAN_PAGE) $(HIGHLIGHT_THEME) $(INC_HEADER_PDF) $(INC_BEFORE_BODY_PDF) $(IMAGES) Makefile
+$(OUT_PDF) : $(SOURCE) $(SOURCE_MAN_PAGE) $(INC_HEADER_PDF) $(INC_BEFORE_BODY_PDF) $(IMAGES) Makefile
 	pandoc $(SOURCE_MAN_PAGE) -f markdown \
 			$(PDF_OPTS) \
 			-o $(TEX_MAN_PAGE)
@@ -165,13 +166,52 @@
 			-V $(MAIN_FONT) -V $(MONO_FONT) -V $(CJK_FONT) \
 			$(TXT_OPTS) \
 			-o $(OUT_TXT)
-	# Indent Man Page sections in TOC and remove trailing spaces
+	# Indent Man Page sections in TOC, remove trailing spaces and echoed image tags
 	sed -i \
 		-e 's/^\(-   [A-Z][A-Z ]*\)$$/    \1/' \
 		-e 's/  *$$//' \
+		-e '/^\[.*\]$$/{N;N;s/\[\(.*\)\]\n\n\1/[\1]/;p;d}' \
 		$(OUT_TXT)
+	# Wrap
+	sed -i '/.\{81\}/{s/.\{80\}/&\n/}' $(OUT_TXT)
 
 $(OUT_MAN_PAGE) : $(SOURCE_MAN_PAGE) Makefile
 	pandoc $(SOURCE_MAN_PAGE) -f markdown \
 			$(MAN_PAGE_OPTS) \
 			-o $(OUT_MAN_PAGE)
+
+# For debugging
+
+manual.tex : $(SOURCE) $(SOURCE_MAN_PAGE) $(INC_HEADER_PDF) $(INC_BEFORE_BODY_PDF) $(IMAGES) Makefile
+	pandoc $(SOURCE_MAN_PAGE) -f markdown \
+			$(PDF_OPTS) \
+			-o $(TEX_MAN_PAGE)
+	sed -i -e 's/section{/subsection{/' $(TEX_MAN_PAGE) # Convert man page sections to subsections
+	pandoc $(SOURCE) -f markdown $(INC_PDF) --toc --toc-depth=4 \
+			-V $(MAIN_FONT) -V $(MONO_FONT) -V $(CJK_FONT) -V block-headings \
+			$(PDF_OPTS) \
+			--include-after-body $(TEX_MAN_PAGE) \
+			-s -o manual.tex
+
+# HTML one-page (uses modified "templates/styles.html", unchanged "templates/default.html")
+
+OUT_HTML = manual.html
+HTML_OPTS = --filter pandoc-tablenos -M tablenos-warning-level=0 --highlight-style=haddock \
+			--template=templates/default.html --eol=lf -s -t html
+INC_BEFORE_BODY_HTML = inc_before_body_html.html
+INC_HTML = --include-before-body $(INC_BEFORE_BODY_HTML)
+TEMPLATES_HTML = templates/default.html templates/styles.html
+
+$(OUT_HTML) : $(SOURCE) $(SOURCE_MAN_PAGE) $(INC_BEFORE_BODY_HTML) $(TEMPLATES_HTML) Makefile
+	pandoc $(SOURCE) $(SOURCE_MAN_PAGE) -f markdown+link_attributes $(INC_HTML) --toc --toc-depth=4 \
+			-V $(MAIN_FONT) -V $(MONO_FONT) -V $(CJK_FONT) \
+			$(HTML_OPTS) \
+			-o $(OUT_HTML)
+	# Indent Man Page sections in TOC, change Man Page sections h1 -> h2, remove Man Page meta, fix Table captions
+	sed -i \
+		-e 's/\(Man Page ZINT(1)<\/a>\)<\/li>/\1<ul>/' \
+		-e 's/\(AUTHORS<\/a><\/li>\)/\1<\/ul><\/li>/' \
+		-e 's/^<h1\([^>]*>[A-Z][A-Z ]*<\/\)h1>$$/<h2\1h2>/' \
+		-e 's/^<p>% ZINT(1)[^<]*<\/p>//' \
+		-e 's/<caption><span>Table\(.:[^:]*\):/<caption><span>Table\1/' \
+		$(OUT_HTML)

=== frontend/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
     target_sources(${PROJECT_NAME} PRIVATE zint.rc)
 endif()
 
-target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_SOURCE_DIR}/backend")
+target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/../backend")
 
 set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "zint")
 
@@ -27,7 +27,7 @@
 
 install(TARGETS ${PROJECT_NAME} DESTINATION "${BIN_INSTALL_DIR}" RUNTIME)
 if(UNIX)
-    install(FILES "${CMAKE_SOURCE_DIR}/docs/zint.1" DESTINATION "${MAN_INSTALL_DIR}/man1" COMPONENT doc)
+    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../docs/zint.1" DESTINATION "${MAN_INSTALL_DIR}/man1" COMPONENT doc)
 endif()
 
 if(ZINT_TEST)

=== frontend_qt/CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
     target_sources(${PROJECT_NAME} PRIVATE res/qtZint.rc)
 endif()
 
-target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_SOURCE_DIR}/backend" "${CMAKE_SOURCE_DIR}/backend_qt")
+target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/../backend" "${CMAKE_CURRENT_SOURCE_DIR}/../backend_qt")
 
 if(ZINT_SHARED)
     target_link_libraries(${PROJECT_NAME} zint)

=== backend/tests/CMakeLists.txt ===
# Copyright (C) 2009-2022 Robin Stuart <rstuart114@gmail.com>
# Adapted from qrencode/tests/CMakeLists.txt
# Copyright (C) 2006-2017 Kentaro Fukuchi <kentaro@fukuchi.org>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.5)
project(zint_backend_tests)

enable_testing()

include(${zint-package_SOURCE_DIR}/cmake/zint_add_test.cmake)

set(BWIPP_TAR ${CMAKE_CURRENT_SOURCE_DIR}/tools/bwipp_dump.ps.tar.xz)
set(BWIPP_PS ${CMAKE_CURRENT_BINARY_DIR}/tools/bwipp_dump.ps)

if(NOT EXISTS ${BWIPP_PS})
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tools)
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar -xf ${BWIPP_TAR}
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tools)
endif()

set(testcommon_SRCS testcommon.c testcommon.h)

if(ZINT_SHARED)
    add_library(testcommon ${testcommon_SRCS})
    target_link_libraries(testcommon zint)
    target_include_directories(testcommon PUBLIC ${zint_backend_tests_SOURCE_DIR})
    if(NOT (ZINT_USE_PNG AND PNG_FOUND))
        target_compile_definitions(testcommon PRIVATE ZINT_NO_PNG)
    endif()
endif()

if(ZINT_STATIC)
    add_library(testcommon-static ${testcommon_SRCS})
    target_link_libraries(testcommon-static zint-static)
    target_include_directories(testcommon-static PUBLIC ${zint_backend_tests_SOURCE_DIR})
    if(NOT (ZINT_USE_PNG AND PNG_FOUND))
        target_compile_definitions(testcommon-static PRIVATE ZINT_NO_PNG)
    endif()
endif()

zint_add_test(2of5 test_2of5)
zint_add_test(auspost test_auspost)
zint_add_test(aztec test_aztec)
zint_add_test(bc412 test_bc412)
zint_add_test(big5 test_big5)
zint_add_test(bmp test_bmp)
zint_add_test(channel test_channel)
zint_add_test(codablock test_codablock)
zint_add_test(code test_code)
zint_add_test(code1 test_code1)
zint_add_test(code128 test_code128)
zint_add_test(code16k test_code16k)
zint_add_test(code49 test_code49)
zint_add_test(common test_common)
zint_add_test(composite test_composite)
zint_add_test(dmatrix test_dmatrix)
zint_add_test(dotcode test_dotcode)
zint_add_test(eci test_eci)
zint_add_test(emf test_emf)
zint_add_test(gb18030 test_gb18030)
zint_add_test(gb2312 test_gb2312)
zint_add_test(gif test_gif)
zint_add_test(gridmtx test_gridmtx)
zint_add_test(gs1 test_gs1)
zint_add_test(hanxin test_hanxin)
zint_add_test(imail test_imail)
zint_add_test(iso3166 test_iso3166)
zint_add_test(iso4217 test_iso4217)
zint_add_test(ksx1001 test_ksx1001)
zint_add_test(large test_large)
zint_add_test(library test_library)
zint_add_test(mailmark test_mailmark)
zint_add_test(maxicode test_maxicode)
zint_add_test(medical test_medical)
zint_add_test(output test_output)
zint_add_test(pcx test_pcx)
zint_add_test(pdf417 test_pdf417)
zint_add_test(plessey test_plessey)
if(ZINT_USE_PNG AND PNG_FOUND)
zint_add_test(png test_png)
endif()
zint_add_test(postal test_postal)
zint_add_test(print test_print)
zint_add_test(ps test_ps)
zint_add_test(qr test_qr)
zint_add_test(raster test_raster)
zint_add_test(reedsol test_reedsol)
zint_add_test(rss test_rss)
zint_add_test(sjis test_sjis)
zint_add_test(svg test_svg)
zint_add_test(telepen test_telepen)
zint_add_test(tif test_tif)
zint_add_test(ultra test_ultra)
zint_add_test(upcean test_upcean)
zint_add_test(vector test_vector)

=== backend_qt/tests/CMakeLists.txt ===
# Copyright (C) 2021-23 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.5)
project(QZint_tests LANGUAGES CXX)

enable_testing()

if(USE_QT6)
    find_package(Qt6Test REQUIRED)
else()
    find_package(Qt5Test REQUIRED)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)

add_executable(test_qzint test_qzint.cpp)
target_link_libraries(test_qzint PRIVATE QZint Qt${QT_VERSION_MAJOR}::Test)
add_test(NAME qzint COMMAND test_qzint)
if(MSVC)
    set_tests_properties(qzint PROPERTIES ENVIRONMENT
        "PATH=${CMAKE_BINARY_DIR}/backend/${CMAKE_BUILD_TYPE}\;${CMAKE_BINARY_DIR}/frontend/${CMAKE_BUILD_TYPE}\;$ENV{PATH}")
else()
    set_tests_properties(qzint PROPERTIES ENVIRONMENT
        "LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/backend;PATH=${CMAKE_BINARY_DIR}/frontend:$ENV{PATH}")
endif()

=== frontend/tests/CMakeLists.txt ===
# Copyright (C) 2020-23 Robin Stuart <rstuart114@gmail.com>
# Adapted from qrencode/tests/CMakeLists.txt
# Copyright (C) 2006-2017 Kentaro Fukuchi <kentaro@fukuchi.org>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.5)
project(zint_frontend_tests)

enable_testing()

include(${zint-package_SOURCE_DIR}/cmake/zint_add_test.cmake)

if(ZINT_SHARED)
    set(ZINT_STATIC "")
endif()
zint_add_test(args test_args)

=== debian/changelog ===
zint (2.13.0-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:55:14 +1100

zint (2.13.0-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:34:50 +0000

zint (2.13.0-1build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 08:47:48 +0000

zint (2.13.0-1) unstable; urgency=medium

  * New upstream release.
  * rules: no longer append "-Wl,--as-needed".
  * Build upstream man page from source.
    + Build-Depends += "pandoc".
  * Install upstream man page and documentation (with doc-base).
  * Updated Homepage to "https://zint.org.uk/" (Closes: #1021692).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 31 Dec 2023 20:19:44 +1100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,20 @@
 Source: zint
 Section: graphics
 Priority: optional
-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Jakob Haufe <sur5r@debian.org>
 Build-Depends: debhelper-compat (= 12)
     ,cmake
     ,libpng-dev
     ,libqt5svg5-dev
+    ,pandoc
     ,qtbase5-dev
     ,qttools5-dev
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/zint
 Vcs-Git: https://salsa.debian.org/debian/zint.git
-Homepage: https://sourceforge.net/projects/zint/
+Homepage: https://zint.org.uk/
 Rules-Requires-Root: no
 
 Package: zint
@@ -74,7 +76,7 @@
  This package contains Zint Barcode Studio, a QT frontend for the Zint
  barcode encoding library.
 
-Package: libzint2.12
+Package: libzint2.13
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -107,7 +109,7 @@
 Package: libzint-dev
 Section: libdevel
 Architecture: any
-Depends: libzint2.12 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libzint2.13 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same
 Description: Zint development files
  Zint is a barcode encoding and image generating library. It currently
